      SUBROUTINE IOALL(IWHAT,JDIM,KDIM,Q,PRESS,SNDSP,XY,XYJ,X,Y)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      PARAMETER (MAXJ=165, MAXK=48, MAXJK=MAXJ*MAXK  )
C
      COMMON/BASE/
     1  JMAX,       KMAX,     JM,          KM,          JBEGIN,   JEND,
     1  KBEGIN,     KEND,     JPLUS(999),  JMINU (999), JLOW,     JUP,
     1  KLOW,       KUP,      PERIDC  ,    NP,          DT,   CP2TIM,
     1  FSMACH,     ALPHA,    GAMMA,       GAMI,        PI,
     1  DIS2X,      DIS2Y,    DIS4X,       DIS4Y,       PHIDT,    
     1  THETAD ,    RESID,    JACDT,       IPRINT,      NPCP,
     1  JTAIL1,     JTAIL2,   NUMITE ,     ISTART,      NSTEPS
      LOGICAL PERIDC  
      COMMON/GRID/DYM,YMAX,XMIN,XMAX,THICK
C
      DIMENSION Q(JDIM,KDIM,4)
      DIMENSION PRESS(JDIM,KDIM),SNDSP(JDIM,KDIM)
      DIMENSION XY(JDIM,KDIM,4),XYJ(JDIM,KDIM)
      DIMENSION X(JDIM,KDIM),Y(JDIM,KDIM)
C
      COMMON/WORKSP/CPBOD(MAXJ),XBOD(MAXJ), WORK2(MAXJ,90)
C
      GO TO (1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17) IWHAT
C
    1 CONTINUE
C
      GO TO 10000
C
C
C***********************************************************************
C
    2 CONTINUE
      GO TO 10000
C
C**********************************************************************
C
C
    3 CONTINUE
C
C
      GO TO 10000
C
C
C***********************************************************************
C          READ THE RESTART
C
    4 CONTINUE
C
C      READ IN A UNFORMATTED RESTART FILE FROM TAPE3.
C      THE Q READ IN IS NOT YET SCALED BY THE METRIC JACOBIAN XYJ,
C      THE RESCALING IS DONE IN INITIA.
C
C  CHANGED TO BE COMPATIBLE WITH  NEW PLOT3D  4/2/86
C
      OPEN(UNIT=3, STATUS='OLD', FORM='UNFORMATTED')
C-old      OPEN(UNIT=3, FILE='FT03.DAT',STATUS='OLD', FORM='UNFORMATTED')
      READ(3) JMAX2,KMAX2
      READ(3) FSMTEM,ALPTEM,RETEM,TOTIME
C
      WRITE(*, 433) TOTIME, ISTART
  433 FORMAT(1H0,12HTOTAL TIME =,F12.6,
     1       10X, 20HSTARTING ITERATION =, I5)
C
      READ(3) ( ( ( Q(J,K,N),J=1,JMAX2) ,K=1,KMAX2) ,N=1,4)
      READ(3) JTITEM, ISTART
C
      GO TO 10000
C
C
C***********************************************************************
C          ITERATION NUMBER AND RESIDUAL WRITTEN TO OUTPUT
C
    5 CONTINUE
C
C
C  COMPUTE NUMBER OF SUPERSONIC POINTS
C
      NSUPER = 0
      DO 501 K = 1,KMAX
          DO 502 J = JLOW,JUP
          RI = 1./Q(J,K,1)
          UV2 = (Q(J,K,2)**2 + Q(J,K,3)**2)*RI**2
C            CHECK MACH**2  ( SAME AS MACH)
          CSPED2 = SNDSP(J,K)**2
          ZS = UV2/CSPED2
             IF( ZS .GE. 1.)NSUPER = NSUPER + 1
502       CONTINUE
501   CONTINUE
C
C          LIFT AND DRAG CALCULATIONS AND OUTPUT ON TAPE6
C
      RSD = RESID
C
C  OUTPUT
C
C
      WRITE(*, 505)NUMITE , RSD, NSUPER, CP2TIM
505   FORMAT(1H ,'  N = ',I6, '  RESID = ',E12.6, 
     1    '  # OF SS PTS = ',I5,'  CPUTIM = ',F10.2)
C
      GO TO 10000
C
C
C***********************************************************************
C          COEFFICIENT OF PRESSURE DATA WRITTEN TO OUTPUT
C
    6 CONTINUE
C
C
      WRITE(*, 666)
666   FORMAT( 1X, 23HCOEFFICIENT OF PRESSURE )
      CPC = 2./(GAMMA*FSMACH**2)
C   COMPUTE CP AT GRID POINTS AND STORE IN Z ARRAY
      DO 665 J=JTAIL1,JTAIL2
         PP = PRESS(J,1)*XYJ(J,1)
         CP = (PP*GAMMA -1.)*CPC
         WRITE(*, 667) J, X(J,1), CP
665   CONTINUE
C
667   FORMAT( 1X, I5, 5X, F14.7, 5X, F14.7)
C
C
      GO TO 10000
C
C***********************************************************************
   7    CONTINUE
      GO TO 10000
C
C***********************************************************************
C
    8 CONTINUE
C
      GO TO 10000
C
C
C***********************************************************************
C
    9 CONTINUE
C
      GO TO 10000
C
C
C***********************************************************************
C          STORE A UNFORMATTED RESTART FILE
C
   10 CONTINUE
C
C     NOTE THAT NUMITE  IS ACTUALLY ONE GREATER THAN THE LAST USED.
C     IT GETS STORED, AND USED AS THE FIRST ITERATION NEXT TIME.
C
C       REWIND BECAUSE THIS MAY BE CALLED PERIDC  ALLY
      OPEN(UNIT=4, STATUS='UNKNOWN', FORM='UNFORMATTED')
C-old      OPEN(UNIT=4, FILE='FT04.DAT',STATUS='NEW', FORM='UNFORMATTED')
      WRITE(4) JMAX,KMAX
      WRITE(4) FSMACH,ALPHA,FSMACH,ALPHA
      WRITE(4) ( ( ( Q(J,K,N)*XYJ(J,K),J=1,JMAX) ,K=1,KMAX) ,N=1,4)
      WRITE(4) JTAIL1, NUMITE 
      REWIND 4
C
      GO TO 10000
C
C***********************************************************************
C
   11 CONTINUE
      GOTO 10000
C***********************************************************************
C
   12 CONTINUE
      GOTO 10000
C***********************************************************************
   13 CONTINUE
      GOTO 10000
C***********************************************************************
C***********************************************************************
   14 CONTINUE
      GOTO 10000
C***********************************************************************
C***********************************************************************
C
   15 CONTINUE
C
C
C    OUTPUT ON TAPE6 9 VARIABLES ALONG THE BODY
C
      K = 1
      WRITE(*,  1510) K
1510  FORMAT( 1X, 4HK = , I4 )
      WRITE(*, 1515)
1515  FORMAT( 1X,
     1   '  J   K     RHO            U             V           ',
     2   'ENERGY      PRESSURE     ',
     3   ' COEFF P    LOCAL MACH     X             Y ')
C
      DO 1590 J = 1, JMAX
         RHO = Q( J, K, 1) * XYJ( J, K)
         U = Q( J, K, 2) / Q( J, K, 1)
         V = Q( J, K, 3) / Q( J, K, 1)
         UVSQ = U**2 + V**2
         ENERGY = Q( J, K, 4) * XYJ( J, K)
         PPP = PRESS(J,K)*XYJ(J,K)
         CPC = 2./(GAMMA*FSMACH**2)
         CP = (PPP * GAMMA - 1. ) * CPC
         CSQ = SNDSP(J,K)
         EMACH = SQRT( UVSQ )/ CSQ 
         XCOORD = X( J, K)
         YCOORD = Y( J, K)
         WRITE(*, 1520) J, K, RHO, U, V, ENERGY, PPP,
     1      CP, EMACH, XCOORD, YCOORD
1520     FORMAT( 1X, 2( I3, 1X), 9( F11.6, 2X ) )
1590   CONTINUE
C
       GOTO 10000
C
C***********************************************************************
C***********************************************************************
C          GRID OUTPUT
C
   16 CONTINUE
C
      OPEN(UNIT=11, STATUS='UNKNOWN', FORM='UNFORMATTED')
C-old      OPEN(UNIT=11, FILE='FT11.DAT',STATUS='NEW', FORM='UNFORMATTED')
      WRITE( 11) JMAX,KMAX
      WRITE( 11)  ( ( X(J,K),J=1,JMAX) ,K=1,KMAX) ,
     +             ( ( Y(J,K),J=1,JMAX) ,K=1,KMAX)
C
C
      GO TO 10000
C
C
C***********************************************************************
C***********************************************************************
C          COMPUTE CIRCULATION, AND PRINT IT OUT ( NOT IN COMMON )
C
   17 CONTINUE
C
C
      GO TO 10000
C
C
C***********************************************************************
C
C
10000 RETURN
      END
